
def gen_vx_names(d):
    return ["vx[%d]" % i for i in range(d)]
def gen_vx_code(d): # FIXME
    num_vertices = d+1 # FIXME
    pre = "const double vx[%d] = { " % (num_vertices*d,)
    lines = [", ".join("c.coordinates[%d][%d]" % (i,j) for j in range(d))
             for i in range(num_vertices)]
    sep = "\n" + (" "*len(pre))
    expr = sep.join(lines)
    post = "\n" + (" "*len(pre)) + "};"
    code = "%s%s%s" % (pre, expr, post)
    return [code]

def gen_x0_names(d):
    return ["x0[%d]" % i for i in range(d)]
def gen_x0_code(d): # FIXME
    expr = ", ".join("1.0"
                     for i in range(d))
    code = "const double x0[%d] = { %s };" % (d, expr)
    return [code]

def gen_G_names(d):
    return ["G[%d]" % i for i in range(d*d)]
def gen_G_code(d): # FIXME
    expr = ", ".join("1.0" if i == j else "0.0"
                     for i in range(d)
                     for j in range(d))
    code = "const double G[%d] = { %s };" % (d*d, expr)
    return [code]

def gen_detG_names(d):
    return ["detG"]
def gen_detG_code(d):
    expr = "1.0" # FIXME
    code = "const double detG = %s;" % expr
    return [code]

def gen_Ginv_names(d):
    return ["Ginv[%d]" % i for i in range(d*d)]
def gen_Ginv_code(d):
    expr = ", ".join("1.0" if i == j else "0.0"
                     for i in range(d)
                     for j in range(d))
    code = "const double Ginv[%d] = { %s };" % (d*d, expr)
    return [code]

def gen_detGsign_names(d):
    return ["detGsign"]
def gen_detGsign_code(d):
    expr = "1.0" # FIXME
    code = "const double detGsign = %s;" % expr
    return [code]

def gen_D_names(d):
    return ["D"]
def gen_D_code(d):
    expr = "1.0" # FIXME
    code = "const double D = %s;" % expr
    return [code]

def gen_n_names(d):
    return ["n[%d]" % i for i in range(d)]
def gen_n_code(d):
    expr = ", ".join("1.0" if i == 0 else "0.0"
                     for i in range(d))
    code = "const double n[%d] = { %s };" % (d, expr)
    return [code]

def gen_K_vol_names(d):
    return ["K_vol"]
def gen_K_vol_code(d):
    expr = "1.0" # FIXME
    code = "const double K_vol = %s;" % expr
    return [code]

def gen_K_rad_names(d):
    return ["K_rad"]
def gen_K_rad_code(d):
    expr = "1.0" # FIXME
    code = "const double K_rad = %s;" % expr
    return [code]

def gen_K_surf_names(d):
    return ["K_surf"]
def gen_K_surf_code(d):
    expr = "1.0" # FIXME
    code = "const double K_surf = %s;" % expr
    return [code]

def gen_F_area_names(d):
    return ["F_area"]
def gen_F_area_code(d):
    expr = "1.0" # FIXME
    code = "const double F_area = %s;" % expr
    return [code]
