# -*- coding: utf-8 -*-
"""
This module contains representation classes for integrals.
"""

# Copyright (C) 2008-2012 Martin Sandve Alnes and Simula Resarch Laboratory
#
# This file is part of SyFi.
#
# SyFi is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# SyFi is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with SyFi. If not, see <http://www.gnu.org/licenses/>.
#
# Modified by Kent-Andre Mardal, 2010.
#
# First added:  2008-08-13
# Last changed: 2012-05-25

#import SyFi
import swiginac

#import ufl
from ufl.permutation import compute_indices
from sfc.common import sfc_assert, sfc_warning, sfc_debug, sfc_error
from sfc.common.utilities import indices_subset
from sfc.codegeneration.codeformatting import indent, row_major_index_string
from sfc.symbolic_utils import symbols, symbol

class IntegralRepresentationBase(object):
    def __init__(self, integrals, formrep, on_facet):
        sfc_debug("Entering IntegralRepresentationBase.__init__")

        sfc_assert(len(integrals) == 1, "Multiple integration modes not implemented.")

        self.integrals = integrals
        self.formrep   = formrep
        self._on_facet = on_facet
        self.options = self.formrep.options.code.integral

        self.classname = formrep.itg_names[integrals[0]]

        sfc_debug("Leaving  IntegralRepresentationBase.__init__")
